# -*- coding: utf-8 -*-
#!/usr/bin/env python
## HomePage http://www.jielee.name/

from __future__ import with_statement
import sys
import os
import string
import httplib
import urllib
import base64
import contextlib
from Cookie import SimpleCookie
import json
import random
from Cookie import SimpleCookie
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.QtNetwork import *

INFO = "douban FM for N900 (0.01)"
CONFIG_FILE='.doubanFM'


try:
    from PyQt4.phonon import Phonon
except ImportError:
    app = QtGui.QApplication(sys.argv)
    QtGui.QMessageBox.critical(None, "Music Player",
            "Your Qt installation does not have Phonon support.",
            QtGui.QMessageBox.Ok | QtGui.QMessageBox.Default,
            QtGui.QMessageBox.NoButton)
    sys.exit(1)


try:
    _T = QString.fromUtf8
except AttributeError:
    _T = lambda s: s

def delete_file_folder(src):
    '''delete files and folders'''
    if os.path.isfile(src):
        try:
            os.remove(src)
        except:
            pass
    elif os.path.isdir(src):
        for item in os.listdir(src):
            itemsrc=os.path.join(src,item)
            delete_file_folder(itemsrc)
        try:
            os.rmdir(src)
        except:
            pass

class Config():
        def __init__(self):
            self.configFile = None
            self.config= {}
            self.configPath=os.path.expanduser('~')+'/'
            #print self.configPath
            self.volume=0.8
            self.channel=1
            self.chInfo="华语"
            self.autologin=0
            self.username=""
            self.password=""

        def _load (self):
            self.configFile = QFile(self.configPath+CONFIG_FILE)
            if not self.configFile.open(QIODevice.ReadOnly):
                self.configFile = None
                return
            strings=self.configFile.readData(512)
            if len(strings)>0:
                self.config= json.read(strings)
                
                try:
                    self.volume=self.config['volume']
                    self.channel=self.config['channel']
                    self.chInfo=self.config['chInfo']
                    self.autologin=self.config['autologin']
                    self.username=self.config['username']
                    self.password=base64.decodestring((self.config['password'])[::-1])[::-1]
                except:
                    return              
                
                #print self.password
            self.configFile.close()
        
        def _save (self):
            self.configFile = QFile(self.configPath+CONFIG_FILE)
            if not self.configFile.open(QIODevice.WriteOnly):
                self.configFile = None
                return
            self.config['volume']=self.volume
            self.config['channel']=self.channel
            self.config['chInfo']=self.chInfo
            self.config['autologin']=self.autologin
            self.config['username']=self.username
            self.config['password']=(base64.encodestring(self.password[::-1]))[::-1]
            self.configFile.writeData( json.write(self.config))
            self.configFile.close()

class _Label(QLabel):
    def __init__(self, parent):
        super(_Label,self).__init__(parent)
    def mousePressEvent(self, event):
        self.emit(SIGNAL("clicked()"))
    def mouseReleaseEvent(self, event):
        self.emit(SIGNAL("released()"))

class labelButton(QLabel):
    def __init__(self, parent, img1,  img2, img3=None, invalid=False):
        super(labelButton,self).__init__(parent)
        self.img1=img1
        self.img2=img2
        self.img3=img3
        self.invalid=invalid
        if self.invalid==False:
            self.setPixmap(self.img1)
        else:
            self.setPixmap(self.img3)    

    def setEnabled (self):
        self.invalid=False
        self.setPixmap(self.img1)
        
    def mousePressEvent(self, event):
        if self.invalid==True:
            return
        self.setPixmap(self.img2)
        self.emit(SIGNAL("clicked()"))

    def mouseReleaseEvent(self, event):
        if self.invalid==True:
            return
        self.setPixmap(self.img1)
        self.emit(SIGNAL("released()"))

class toggleButton(QLabel):
    def __init__(self, parent, img1,  img2, img3=None, invalid=False):
        super(toggleButton,self).__init__(parent)
        self.img1=img1
        self.img2=img2
        self.img3=img3
        self.invalid=invalid
        self.clicked=False
        if self.invalid==False:
            self.setPixmap(self.img1)
        else:
            self.setPixmap(self.img3)    

    def setEnabled (self):
        self.invalid=False
        self.setPixmap(self.img1)

    def setClicked (self):
        if self.invalid==True:
            return
        self.setPixmap(self.img2)
        self.clicked=True
        
    def setUnClicked (self):
        if self.invalid==True:
            return
        self.setPixmap(self.img1)
        self.clicked=False

    def mousePressEvent(self, event):
        if self.invalid==True:
            return
        if self.clicked==False:
            self.setPixmap(self.img2)
            self.clicked=True
        else:
            self.setPixmap(self.img1)
            self.clicked=False
        self.emit(SIGNAL("clicked()"))

class Song():
        def __init__(self,pic,url,title,artist,album,company,sid,aid,like):
            self.pic=pic
            self.url=url
            self.title=title
            self.artist=artist
            self.album=album
            self.company=company
            self.sid=sid
            self.aid=aid
            self.like=like


class DoubanFmWidget(QLabel):
    def __init__(self, parent):
        QLabel.__init__(self, parent)
        self.setMinimumSize(480, 288)
        self.setMaximumSize(480, 288)
        self.parent = parent
        self.color = QColor(207, 207, 207)
        self.setStyleSheet("QWidget { background-color: %s }" % self.color.name())
        #setup ui
        self.picture = QLabel(self)
        self.picture.setAlignment(Qt.AlignCenter)
        self.picture.setWordWrap(True)
        self.picture.setObjectName(_T("picture"))
        self.picture.setMinimumSize(QSize(132, 132))
        self.picture.setMaximumSize(QSize(132, 132))
        image = QImage()
        if not image.load('./icons/bg.png'):
            self.picture.setText("Image can not be loaded.")
        else:
            self.picture.setPixmap(QPixmap.fromImage(image))
        self.picture.move(15,75)

        self.label = QLabel(self)
        self.label.setMinimumSize(QSize(300, 70))
        self.label.setMaximumSize(QSize(300, 70))
        self.label.setStyleSheet("background-color: #fff")
        self.label.move(160,90)

        self.label_setting=labelButton(self,QPixmap('./icons/setting.png'), QPixmap('./icons/setting_clicked.png'))
        self.label_setting.move(412,48)
        self.label_setting.setAlignment(Qt.AlignCenter|Qt.AlignVCenter)
        self.label_setting.setMinimumSize(QSize(48, 36))
        self.label_setting.setMaximumSize(QSize(48, 36))

        self.label_skip=labelButton(self,QPixmap('./icons/skip.png'), QPixmap('./icons/skip_clicked.png'))
        self.label_skip.move(410,190)

        self.label_delete=labelButton(self,QPixmap('./icons/delete.png'), QPixmap('./icons/delete_clicked.png'), QPixmap('./icons/delete_invalid.png'),True)
        self.label_delete.move(330,190)

        self.label_favorite=toggleButton(self,QPixmap('./icons/favorite.png'), QPixmap('./icons/favorite_clicked.png'), QPixmap('./icons/favorite_invalid.png'),True)
        self.label_favorite.move(250,190)

        self.label_volume=labelButton(self,QPixmap('./icons/volume.png'), QPixmap('./icons/volume_clicked.png'))
        self.label_volume.setStyleSheet("background-color: #fff")
        self.label_volume.setAlignment(Qt.AlignCenter|Qt.AlignVCenter)
        self.label_volume.setMinimumSize(QSize(40, 32))
        self.label_volume.setMaximumSize(QSize(40, 32))
        self.label_volume.move(415,124)

        font16 = QFont()
        font16.setPointSize(16)

        self.label_time = _Label(self)
        self.label_time.setFont(font16)
        self.label_time.setText("<b> <font style='background-color: #fff; color:#888'>"+'00:00'+"</font></b>") 
        #self.label_time.setTextFormat(1)
        self.label_time.move(165,95)
        
        font12 = QFont()
        font12.setPointSize(12)

        self.label_channel = _Label(self)
        self.label_channel.setMinimumSize(QSize(120, 25))
        self.label_channel.setMaximumSize(QSize(120, 25))
        self.label_channel.setAlignment(Qt.AlignRight|Qt.AlignTrailing|Qt.AlignVCenter)
        self.label_channel.setFont(font12)
        self.label_channel.setStyleSheet("background-color: #fff")
        self.label_channel.setText("<font style='background-color: #BACABD; color:#fff'>"+_T("")+"</font>") 
        self.label_channel.move(332,95)
        
        self.label_songTitle = _Label(self)
        self.label_songTitle.setMinimumSize(QSize(240, 25))
        self.label_songTitle.setMaximumSize(QSize(240, 25))
        self.label_songTitle.setAlignment(Qt.AlignLeft|Qt.AlignVCenter)
        self.label_songTitle.setFont(font12)
        self.label_songTitle.setStyleSheet("background-color: #fff")
        self.label_songTitle.setText("<font style='color:#777'> "+_T("")+"</font>") 
        self.label_songTitle.move(165,130)

    def displayTime (self,str):
        self.label_time.setText("<b> <font style='background-color: #fff; color:#888'>"+str+"</font></b>")

    def displaySongInfo (self,str):
        self.label_songTitle.setText("<font style='color:#777'> "+str+"</font>") 

    def displayChannel (self,str):
        self.label_channel.setText("<font style='background-color: #BACABD; color:#fff'>"+str+"MHz</font>") 

    def displayPicture (self,str):
        image = QImage()
        if str is None or len(str)==0:
            image.load('./icons/bg.png')
            self.picture.setPixmap(QPixmap.fromImage(image))
            return
        
        try:
            image.load(str)
            self.picture.setPixmap(QPixmap.fromImage(image))
        except:
            image.load('./icons/bg.png')
            self.picture.setPixmap(QPixmap.fromImage(image))

### code.google.com/p/dbfmplugin/
class DoubanLoginException(Exception):
    pass
class DoubanFmThread(QThread):
    getPlayList = pyqtSignal(object)
    def __init__(self, parent = None):
        QThread.__init__(self, parent)
        self.exiting = False
        self.http = QHttp(self)
        self.params=None
        self.ignoreResponse = False
        self.logined = False
        self.config=None
        self.uid = None
        self.dbcl2 = None
        self.bid = None
        #self.__login(username, password)
        #self.__load_channels()

    def __del__(self):
        self.exiting = True
        self.wait()

    def run(self):
        if self.config.autologin==1 and self.logined==False:
            self.__login(self.config.username,self.config.password)
            self.logined=True
            #print 'logined'

        results = self.__remote_fm(self.params)
        if self.ignoreResponse == False:
            self.getPlayList.emit(results)
        self.ignoreResponse = False

    def __login(self, username, password):
        """
        login douban, get the session token
        """
        data = urllib.urlencode({'source':'simple',
                'form_email':username, 'form_password':password})
        contentType = "application/x-www-form-urlencoded"

        self.__get_bid()
        cookie = "bid=%s" % self.bid

        headers = {"Content-Type":contentType, "Cookie": cookie }
        with contextlib.closing(httplib.HTTPSConnection("www.douban.com")) as conn:
            conn.request("POST", "/accounts/login", data, headers)
        
            r1 = conn.getresponse()
            resultCookie = SimpleCookie(r1.getheader('Set-Cookie'))

            if not resultCookie.has_key('dbcl2'):
                return#raise DoubanLoginException()

            dbcl2 = resultCookie['dbcl2'].value
            if dbcl2 is not None and len(dbcl2) > 0:
                self.dbcl2 = dbcl2
                #print dbcl2
                uid = self.dbcl2.split(':')[0]
                self.uid = uid
    
    def __get_bid(self):
        conn = httplib.HTTPConnection("www.douban.com")
        conn.request("GET", "/accounts/login")
        resp = conn.getresponse()
        cookie = resp.getheader('Set-Cookie')
        cookie = SimpleCookie(cookie)
        conn.close()
        if not cookie.has_key('bid'):
            raise DoubanLoginException()
        else:
            self.bid = cookie['bid']
            return self.bid

    def __remote_fm(self, params):
        """
        io with douban.fm
        """
        data = urllib.urlencode(params)
        #print data
        if self.bid is not None:
            cookie = 'dbcl2="%s"; bid="%s"' % (self.dbcl2, self.bid)
        else:
            cookie = ''
        header = {"Cookie": cookie}
        with contextlib.closing(httplib.HTTPConnection("douban.fm")) as conn:
            conn.request('GET', "/j/mine/playlist?"+data, None, header)
            result = conn.getresponse().read()
            return result

    def __format_list(self, sidlist, verb=None):
        """
        for sidlist with ite verb status
        """
        if sidlist is None or len(sidlist) == 0:
            return ''
        else:
            if verb is not None:
                return ''.join(map(lambda s: '|'+str(s)+':'+str(verb), sidlist))
            else:
                return ''.join(map(lambda s: '|'+str(s), sidlist))
   
    def __get_default_params (self, typename=None):
        """
        default request parameters, for override
        """
        params = {}
        for i in ['aid', 'channel', 'du', 'h', 'r', 'rest', 'sid', 'type', 'uid']:
            params[i] = ''

        params['r'] = random.random()
        if self.uid is not None:
            params['uid'] = self.uid
        params['channel'] = self.config.channel

        if typename is not None:
            params['type'] = typename
        return params

### playlist related 
    def new_playlist(self,config,history=None):
        """
        retrieve a new playlist
        * history -  history song ids. optional.
        """
        self.config=config
        self.params = self.__get_default_params('n')
        self.params['h'] = self.__format_list(history, True)
        self.start()
        
                
    def del_song(self, sid, aid, rest=[]):
        """
        delete a song from your playlist
        * sid - song id
        * aid - album id
        * rest - rest song ids in current playlist
        """
        self.params = self.__get_default_params('b')
        self.params['sid'] = sid
        self.params['aid'] = aid
        self.params['rest'] = self.__format_list(rest)
        self.start()
        self.ignoreResponse = True

    def fav_song(self, sid, aid):
        """
        mark a song as favorite
        * sid - song id
        * aid - album id
        """
        self.params = self.__get_default_params('r')
        self.params['sid'] = sid
        self.params['aid'] = aid

        self.start()
        ## ignore the response
        self.ignoreResponse = True

    def unfav_song(self, sid, aid):
        """
        unmark a favorite song
        * sid - song id
        * aid - album id
        """
        self.params = self.__get_default_params('u')
        self.params['sid'] = sid
        self.params['aid'] = aid
        self.start()
        ## ignore the response
        self.ignoreResponse = True

    def skip_song(self, sid, aid, history=[]):
        """
        skip a song, tell douban that you have skipped the song.
        * sid - song id
        * aid - album id
        * history - your playlist history(played songs and skipped songs)
        """
        self.params = self.__get_default_params('s')
        self.params['h'] = self.__format_list(history[:50])
        self.params['sid'] = sid
        self.params['aid'] = aid
        self.start()

    def played_song(self, sid, aid, du=0):
        """
        tell douban that you have finished a song
        * sid - song id
        * aid - album id
        * du - time your have been idle
        """
        self.params  = self.__get_default_params('e')
        self.params['sid'] = sid
        self.params['aid'] = aid
        self.params['du'] = du

        self.start()
        ## ignore the response
        self.ignoreResponse = True

    def played_list(self, history=[]):
        """
        request more playlist items
        * history - your playlist history(played songs and skipped songs)
        """
        self.params = self.__get_default_params('p')
        self.params['h'] = self.__format_list(history[:50])
        self.start()


class downloadThread(QThread):
    requestFinished = pyqtSignal(object)
    def __init__(self, parent = None):
        QThread.__init__(self, parent)
        self.exiting = False
        self.tmpPath='/tmp'#os.path.expandvars('$TMP')
        if QDir(self.tmpPath).exists():
            self.tmpPath=self.tmpPath+'/doubanFM/'
        else:
            self.tmpPath='./doubanFM/'
        #print self.tmpPath
        self.outFile = None
        self.outDir = None
        self.httpGetId = 0
        self.httpRequestAborted = False
        self.url=''
        self.http = QHttp(self)
        self.http.requestFinished.connect(self.httpRequestFinished)

    def __del__(self):
        self.exiting = True
        self.wait()

    def run(self):
        url = QUrl(self.url)
        fileInfo = QFileInfo(url.path())
        fileName = fileInfo.fileName()
        self.outDir=QDir(self.tmpPath)
        if not self.outDir.exists() :
            self.outDir.mkpath(self.tmpPath)

        if QFile.exists(self.tmpPath+fileName):
            QFile.remove(self.tmpPath+fileName)

        self.outFile = QFile(self.tmpPath+fileName)
        if not self.outFile.open(QIODevice.WriteOnly):
            self.outFile = None
            return
        port = url.port()
        if port == -1:
            port = 0
        self.http.setHost(url.host(), QHttp.ConnectionModeHttp, port)
        self.httpRequestAborted = False
        path = QUrl.toPercentEncoding(url.path(), "!$&'()*+,;=:@/")
        if path:
            try:
                # Python v3.
                path = str(path, encoding='utf-8')
            except TypeError:
                # Python v2.
                path = str(path)
        else:
            path = '/'

        self.httpGetId = self.http.get(path, self.outFile)


    def _download (self,url):
        self.url=url
        self.start()

    def _delete (self,fileName):
        if QFile.exists(self.tmpPath+fileName):
            QFile.remove(self.tmpPath+fileName)

    def _exit (self):
        #self.outDir.remove(self.tmpPath)
        delete_file_folder(self.tmpPath)
     

    def httpRequestFinished(self, requestId, error):
        if requestId != self.httpGetId:
            return
        if self.httpRequestAborted:
            if self.outFile is not None:
                self.outFile.close()
                self.outFile.remove()
                self.outFile = None
            return
        self.outFile.close()
        if error:
            self.outFile.remove()
            #print( "Download failed: %s." % self.http.errorString())
        else:
            fileName = QFileInfo(QUrl(self.url).path()).fileName()
            self.requestFinished.emit(self.tmpPath+fileName)
        self.outFile = None
    def readResponseHeader(self, responseHeader):
        # Check for genuine error conditions.
        if responseHeader.statusCode() not in (200, 300, 301, 302, 303, 307):
            print("Download failed: %s.\n" % responseHeader.reasonPhrase())
            self.httpRequestAborted = True
            self.progressDialog.hide()
            self.http.abort()  


#setChannelWidget
class setChannelWidget(QWidget):
    setChannel = pyqtSignal(object)
    def __init__(self, parent=None):
        super(setChannelWidget, self).__init__(parent)
        self.setMinimumSize(240, 160)
        #self.setMaximumSize(480, 288)
        self.channelFile = None
        self.config=None
        self.channels = None
        self.channelChanged=0

        self.publicGroupBox = QGroupBox(_T("公共电台"))
        self.channelButton = QPushButton(_T("选 择"),self)
        self.channelButton.setMaximumWidth (self.channelButton.sizeHint().width()+20)
        self.channelButton.setDefault(True)
        self.channelCombo = QComboBox()
        self.channelCombo.setMinimumWidth (135)
        self.channelCombo.addItem('loading...',1)
        self.channelCombo.setEnabled(False)
        layout1 = QGridLayout()
        layout1.addWidget(QLabel(_T("   ")), 0, 0)
        layout1.addWidget(self.channelCombo, 0, 1, 1, 2)
        layout1.addWidget(self.channelButton, 0, 3)
        #layout1.setSpacing(10)
        self.publicGroupBox.setLayout(layout1)

        self.userEdit = QLineEdit()
        self.passwdEdit = QLineEdit()
        self.passwdEdit.setEchoMode(QLineEdit.Password) 
        self.privateGroupBox = QGroupBox(_T("私人电台"))
        self.loginButton = QPushButton(_T("登 陆"),self)
        self.loginButton.setMaximumWidth (self.channelButton.sizeHint().width()+20)
        self.logoutButton = QPushButton(_T("注 销"),self)
        self.logoutButton.setMaximumWidth (self.channelButton.sizeHint().width()+20)

        layout2 = QGridLayout()
        layout2.addWidget(QLabel(_T("邮箱:")), 0, 0)
        layout2.addWidget(self.userEdit, 0, 1, 1, 2)
        layout2.addWidget(QLabel(_T("密码:")), 1, 0)
        layout2.addWidget(self.passwdEdit, 1, 1, 1, 2)
        layout2.addWidget(self.loginButton, 0, 3)
        layout2.addWidget(self.logoutButton, 1, 3)
        self.privateGroupBox.setLayout(layout2)

        mainLayout = QVBoxLayout()
        mainLayout.setMargin(10)
        mainLayout.addWidget(self.publicGroupBox)
        mainLayout.addWidget(self.privateGroupBox)
        self.setLayout(mainLayout)

        self.channelButton.clicked.connect(self._channelButtonClicked)
        self.loginButton.clicked.connect(self._loginButtonClicked)
        self.logoutButton.clicked.connect(self._logoutButtonClicked)

        self.setWindowTitle(_T("换台"))
        self.downloadCh = downloadThread()
        self.downloadCh.requestFinished.connect(self._load_channels)
        self.downloadCh._download("http://www.douban.com/j/app/radio/channels")

    def _channelButtonClicked(self):
        self.config.channel =int( (self.channelCombo.itemData(self.channelCombo.currentIndex())).toString() )
        for channel in self.channels:
            if channel['channel_id']==self.config.channel:
                self.config.chInfo = channel['name']
        self.channelChanged=1
        self.close()
    
    def _loginButtonClicked(self):
        try:
            # Python v3.
            self.config.username = str(self.userEdit.text(), encoding='utf-8')
        except TypeError:
            # Python v2.
            self.config.username = str(self.userEdit.text())
        try:
            # Python v3.
            self.config.password = str(self.passwdEdit.text(), encoding='utf-8')
        except TypeError:
            # Python v2.
            self.config.password = str(self.passwdEdit.text())
        self.config.chInfo = "私人"
        self.config.channel=0
        self.config.autologin=1
        self.channelChanged=2
        self.close()

            
    def _logoutButtonClicked (self):
        self.logoutButton.setEnabled(False)
        self.config.password=''
        self.config.autologin=0
        self.passwdEdit.setText('')
        
    def closeEvent(self, event):
        self.downloadCh.exit()
        if self.channelChanged>0:
            self.setChannel.emit(self.channelChanged)

    def _load_channels(self,data):
        self.downloadCh.exit()
        self.channelCombo.clear()
        self.channelCombo.setEnabled(True)
        self.channelFile = QFile(data)
        if not self.channelFile.open(QIODevice.ReadOnly):
            self.channelFile = None
            return
        self.channels=json.read(self.channelFile.readData(4096))['channels']
        self.channelFile.close()
        for channel in self.channels:
            if channel['channel_id'] is not 0:
                self.channelCombo.addItem(_T(channel['name']),channel['channel_id'])

    def setWindow(self, flags,config):
        super(setChannelWidget, self).setWindowFlags(flags)   
        self.config=config
        self.userEdit.setText(self.config.username)
        self.passwdEdit.setText(self.config.password)
        if self.config.autologin==1:
            self.logoutButton.setEnabled(True)
        else:   
            self.logoutButton.setEnabled(False)
            


        

class DoubanFm(QWidget):
    def __init__(self, parent=None):
        QWidget.__init__(self, parent)

        self.setWindowTitle(_T('豆瓣FM'))
        #self.resize(480, 288)
        self._center()
        self.color = QColor(123, 202, 119)
        #self.setStyleSheet("QWidget { background-color: %s }" % self.color.name())
        self.setAttribute(Qt.WA_TranslucentBackground) 
        self.setWindowIcon(QIcon('./icons/doubanFM.ico'))
        #self.setWindowOpacity(0.8) 
        #self.setMask(QRegion (0, 0, 480, 288))

        self.gridlayout = QGridLayout(self)
        self.gridlayout.setObjectName(_T("mainLayout"))
        self.gridlayout.setMargin(0)
        
        #config
        self.config=Config()
        self.config._load()

        self.wid = DoubanFmWidget(self)
        self.gridlayout.addWidget(self.wid, 0, 0)
        
        #widget event
        self.connect(self.wid.label_skip, SIGNAL('clicked()'),self._next)
        self.connect(self.wid.label_time, SIGNAL('clicked()'),self._pause)
        self.connect(self.wid.label_songTitle, SIGNAL('clicked()'),self._pause)
        self.connect(self.wid.label_volume, SIGNAL('clicked()'),self._setVolume)
        self.connect(self.wid.label_setting, SIGNAL('clicked()'),self._setChannel)
        self.connect(self.wid.label_favorite, SIGNAL('clicked()'),self._favorite)
        self.connect(self.wid.label_delete, SIGNAL('clicked()'),self._delete)
        
        self._setInfo()
        self.dia=None
        #thread
        self.thread = DoubanFmThread()
        self.thread.getPlayList.connect(self._processList)

        
        self.downloadPic = downloadThread()
        self.downloadPic.requestFinished.connect(self._processPicture)

        #Phonon
        self.songIndex=0
        self.playing=0
        self.songs = []
        self.audioOutput = Phonon.AudioOutput(Phonon.MusicCategory, self)#Phonon.CommunicationCategory
        self.mediaObject = Phonon.MediaObject(self)
        self.currentSource = None
        self.mediaObject.setTickInterval(250)
        self.audioOutput.setVolume(self.config.volume)
        self.mediaObject.setTransitionTime(0)
        #print 'volume: ',self.audioOutput.volume(),'\n'
        self.volumeSlider = Phonon.VolumeSlider(self.wid)
        self.volumeSlider.setAudioOutput(self.audioOutput)
        self.volumeSlider.move(220,160)
        self.volumeSlider.setMaximumSize (240,20)
        self.volumeSlider.setMinimumSize (240,20)
        self.volumeSlider.setVisible (False)
        
        #event
        self.mediaObject.tick.connect(self._tick)
        Phonon.createPath(self.mediaObject, self.audioOutput)
        self.mediaObject.aboutToFinish.connect(self._finish)
        self.mediaObject.finished.connect(self._finish)

        #start
        self.wid.displayChannel(_T(self.config.chInfo))
        self.thread.new_playlist(self.config)

    def _play(self):
        self.downloadPic._download(self.songs[self.songIndex].pic)
        url=QUrl(self.songs[self.songIndex].url)
        self.setWindowTitle(_T(self.songs[self.songIndex].title)+' - '+_T('豆瓣FM'))
        self.wid.displaySongInfo(_T(self.songs[self.songIndex].title+' - '+self.songs[self.songIndex].artist))
        if self.songs[self.songIndex].like=='1':
            self.wid.label_favorite.setClicked()
        else:
            self.wid.label_favorite.setUnClicked()
        self.currentSource=Phonon.MediaSource(url)
        #self.currentSource.setAutoDelete(True) 
        self.mediaObject.setCurrentSource(self.currentSource)
        self.playing=1
        self.mediaObject.play()

    def _next (self):
        self._stop()
        self.songIndex=self.songIndex+1
        #print self.songIndex
        #print len(self.songs)
        if self.songIndex<len(self.songs):
            self.downloadPic._download(self.songs[self.songIndex].pic)
            url=QUrl(self.songs[self.songIndex].url)
            self.setWindowTitle(_T(self.songs[self.songIndex].title)+' - '+_T('豆瓣FM'))
            self.wid.displaySongInfo(_T(self.songs[self.songIndex].title+' - '+self.songs[self.songIndex].artist))
            if self.songs[self.songIndex].like=='1':
                self.wid.label_favorite.setClicked()
            else:
                self.wid.label_favorite.setUnClicked()
            self.currentSource=Phonon.MediaSource(url)
            #self.currentSource.setAutoDelete(True) 

            self.mediaObject.setCurrentSource(self.currentSource)
            self.playing=1
            self.mediaObject.play()
        else:
            self.songIndex=0
            #self.songs=None
            self.thread.new_playlist(self.config)

    def _processList (self,str):
        datas=json.read(str)['song']
        if len(datas)>0:
            self.songs=None
            self.songs=map(self.buildSongObject,datas)
            if self.songs is None or len(self.songs)==0:
                self.thread.new_playlist(self.config)
                return
            #print self.songs[0].url
            self.wid.displayChannel(_T(self.config.chInfo))
            if self.config.autologin==1:
                self.wid.label_favorite.setEnabled()    
                self.wid.label_delete.setEnabled()  
            self._play()
        else:
            print 'get list error! \n'
            self.songs=None
            self.thread.new_playlist(self.config)
    
        
    def _stop(self):
        self.mediaObject.stop()
        self.setWindowTitle(_T('豆瓣FM'))
        if self.playing==1:
            self.wid.displaySongInfo('')
            self.wid.displayTime('00:00')
            self.playing=0
            self.downloadPic._delete(QFileInfo(QUrl(self.songs[self.songIndex].pic).path()).fileName())
            self.wid.displayPicture('')


    def _pause(self):
        if self.playing==1:
            self.setWindowTitle(_T('[暂停]')+_T(self.songs[self.songIndex].title)+_T(' - 豆瓣FM'))
            self.mediaObject.pause()
        else:
            self.setWindowTitle(_T(self.songs[self.songIndex].title)+' - '+_T('豆瓣FM'))
            self.mediaObject.play()
        self. playing=1-self.playing

    def _favorite (self):
        if self.songs[self.songIndex].like=='0':
            self.songs[self.songIndex].like='1'
            self.thread.fav_song(self.songs[self.songIndex].sid, self.songs[self.songIndex].aid)
        else:
            self.songs[self.songIndex].like='0'
            self.thread.unfav_song(self.songs[self.songIndex].sid, self.songs[self.songIndex].aid)
    
    def _delete (self):
        self.thread.del_song(self.songs[self.songIndex].sid, self.songs[self.songIndex].aid)
        self._next()
        
    def _finish(self):
        #self.thread.played_song(self.songs[self.songIndex].sid, self.songs[self.songIndex].aid)
        self._next()

    def _setChannel (self):
        self.dia=setChannelWidget()
        self.dia.setWindow(Qt.Dialog,self.config)
        self.dia.show()
        self.dia.setChannel.connect(self._processChannel)
        
        #QMessageBox.about(self, "About Menu","The <b>Menu</b> example show.")

    def _processChannel (self,changed):
        self.dia.setChannel.disconnect(self._processChannel)
        if changed==1:
             self._stop()
             self.wid.displayChannel(_T(self.config.chInfo))
             self.thread.new_playlist(self.config)   
        if changed==2:
            if len(self.config.username)>0 and len(self.config.password)>0:
                self._stop()
                self.wid.displayChannel(_T(self.config.chInfo))
                self.thread.new_playlist(self.config)
            

    def _setInfo(self):
        self.label_info = _Label(self)
        self.label_info.setMinimumSize(QSize(250, 25))
        self.label_info.setMaximumSize(QSize(250, 25))
        self.label_info.setAlignment(Qt.AlignRight|Qt.AlignVCenter)
        #self.label_info.setStyleSheet("background-color: #7bca77")
        self.label_info.setText("<font style='color:#555'> "+_T(INFO)+"</font>") 
        _pos = QDesktopWidget().screenGeometry()
        self.label_info.move(_pos.width()-280,_pos.height()-100)
        
    def _processPicture (self,str):
        if len(str)>0:
            self.wid.displayPicture(str)
      
    def _tick(self, time):
        displayTime = QTime(0, (time / 60000) % 60, (time / 1000) % 60)
        self.wid.displayTime(displayTime.toString('mm:ss'))

    def buildSongObject(self,s):
			song=Song(s['picture'],s['url'],s['title'],s['artist'],s['albumtitle'],s['company'] if 'company' in s else '',s['sid'],s['aid'],s['like'])
			return song
            
    def _center(self):
        screen = QDesktopWidget().screenGeometry()
        size =  self.geometry()
        self.move((screen.width()-size.width())/2, (screen.height()-size.height())/2)
    
    def _setVolume (self):
        self.volumeSlider.setVisible (True)
        
    def mousePressEvent(self, event):
        self.volumeSlider.setVisible (False)

    def closeEvent(self, event):
        self._stop()
        self.config.volume=self.audioOutput.volume()
        self.config._save()
        self.thread.quit()
        self.downloadPic._exit()
        if self.dia is not None:
            self.dia.close()

if __name__ == '__main__':
    app = QApplication(sys.argv)
    app.setApplicationName("doubanFM")
    ui = DoubanFm()
    ui.show()
    sys.exit(app.exec_())
